## httraqt 1.4.7

=== CMakeLists.txt ===
PROJECT(httraqt)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(SET CMP0003 OLD)
CMAKE_POLICY(SET CMP0015 OLD)

# if you use the version 5, please change it to 5
SET(USE_QT_VERSION 4)

MESSAGE("Qt version for compiling: " ${USE_QT_VERSION})

IF(NOT ${USE_QT_VERSION} MATCHES "4" AND NOT ${USE_QT_VERSION} MATCHES "5")
    MESSAGE(FATAL_ERROR "-- Qt version must be set to 4 or 5!")
ENDIF()

# INCLUDE(CPack)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(FindPkgConfig)

# SET(TARGET_NAME httraqt )

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

INCLUDE(HTTRAQTOutOfSourceBuild) # Disallow in-source builds
INCLUDE(HTTRAQTGenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(HTTRAQTDependencies)
INCLUDE(HTTRAQTWordSize) # Detect 32/64 bit platform
INCLUDE(HTTRAQTCompiler) # Detect problematic compilers

# Set the HTTraQt version
#cat README | grep -E  '^[0-9]+\.[0-9]+\.[0-9]+' | head -n 1
EXECUTE_PROCESS (
   COMMAND cat README
   COMMAND grep -E  "^[0-9]+\\.[0-9]+\\.[0-9]+"
   COMMAND head -n 1
   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
   RESULT_VARIABLE HTTQTVERSION
   OUTPUT_VARIABLE DESCRIBE_STRING
   OUTPUT_STRIP_TRAILING_WHITESPACE)



IF(NOT DESCRIBE_STRING)
        SET(DESCRIBE_STRING "no valid git tag for ${PROJECT_NAME} found")
ELSE()
        STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" HTTRAQT_VERSION "${DESCRIBE_STRING}" )
        IF (NOT HTTRAQT_VERSION)
                SET(DESCRIBE_STRING "no valid git tag ${PROJECT_NAME}-x.x.x found")
        ENDIF()
ENDIF()


set(APP_RESOURCES  "${PROJECT_SOURCE_DIR}/sources/httraqt.qrc")


MESSAGE("-- Version info: ${HTTRAQT_VERSION}") 
SET(VERSION ${HTTRAQT_VERSION})

EXECUTE_PROCESS (
      COMMAND date +"%d %b %Y"
      COMMAND sed -e "s/\"//g"
      OUTPUT_VARIABLE BUILD_DATE
      OUTPUT_STRIP_TRAILING_WHITESPACE)

MESSAGE("-- Version build date: ${BUILD_DATE}")

configure_file (
  "${PROJECT_SOURCE_DIR}/sources/version.h.in"
  "${PROJECT_SOURCE_DIR}/sources/version.h" )

# 
SET(HTTRAQT_PACKAGE httraqt)
# SET(HTTRAQT_VERSION ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION})
SET(HTTRAQT_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2015, Eduard Kalinowski. All Rights Reserved.")
SET(HTTRAQT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
IF(WIN32 AND MSVC)
    SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
ELSE(WIN32 AND MSVC)
    SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
ENDIF(WIN32 AND MSVC)


IF(${USE_QT_VERSION} MATCHES "4")
    FIND_PACKAGE(Qt4 REQUIRED)

    INCLUDE(FindQt4)
    IF(NOT QT4_FOUND)
        MESSAGE(FATAL_ERROR "Qt4 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT QT4_FOUND)
ELSE()
    FIND_PACKAGE (Qt5Widgets)
    FIND_PACKAGE (Qt5Multimedia)
    FIND_PACKAGE (Qt5DBus)

    IF(NOT Qt5Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT Qt5Widgets_FOUND)
ENDIF()


INCLUDE(HTTRAQTFindHttrack)

SET( HTTRACK_INCLUDES_DIR "" )

IF(${USE_QT_VERSION} MATCHES "4")
  INCLUDE_DIRECTORIES(${QT_INCLUDES})
    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
    LINK_DIRECTORIES(${QT_LIBRARY_DIR})
    MESSAGE(STATUS "QT_LIBRARY_DIR ${QT_LIBRARY_DIR}")
ELSE()
    INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS})
    MESSAGE(STATUS "QT_INCLUDES  ${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS}")
#     LINK_DIRECTORIES(${Qt5Core_LIBRARIES}, ${Qt5Multimedia_LIBRARIES}, ${Qt5DBus_LIBRARIES}, ${Qt5Widgets_LIBRARIES})
#     MESSAGE(STATUS "QT_LIBRARY_DIR ${Qt5Core_LIBRARIES}, ${Qt5Multimedia_LIBRARIES}, ${Qt5DBus_LIBRARIES}, ${Qt5Widgets_LIBRARIES}")
    SET(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
ENDIF()

SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

SET ( QT_USE_QTDBUS 1 )
  
ADD_SUBDIRECTORY(sources/main)
ADD_SUBDIRECTORY(sources/options)
#ADD_SUBDIRECTORY(sources/icons)


INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR}  ${CMAKE_SOURCE_DIR} $(CMAKE_CURRENT_SOURCE_DIR)/sources/options/includes $(CMAKE_CURRENT_SOURCE_DIR)/sources/main/includes )

IF(${USE_QT_VERSION} MATCHES "4")
    #QT4_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT4_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT4_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT4_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ELSE()
    #QT5_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT5_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT5_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT5_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()


INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR} ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE(${QT_USE_FILE})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_PROJECT -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT)
ELSE()
    ADD_DEFINITIONS( ${Qt5Widgets_DEFINITIONS})
ENDIF()

ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES} 
    ${MAIN_SOURCES}
    ${OPT_SOURCES}
    ${APP_HEADERS_MOC} 
    ${APP_FORMS_HEADERS} 
    ${APP_RESOURCES_RCC}
)


IF(${USE_QT_VERSION} MATCHES "4")
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} httrack)
ELSE()
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${Qt5Widgets_LIBRARIES} ${Qt5DBus_LIBRARIES} httrack)
ENDIF()

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/sources/main ${CMAKE_SOURCE_DIR}/sources/options
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
# MESSAGE("CMAKE_SOURCE_DIR main ${CMAKE_SOURCE_DIR}")
# MESSAGE("CMAKE_CURRENT_BINARY_DIR main ${CMAKE_CURRENT_BINARY_DIR}")
# INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


# Setup module enabled/disabled defaults ...
IF(WIN32)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(WIN32)

IF(UNIX AND NOT APPLE)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT ON)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)


OPTION(HTTRAQT_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(HTTRAQT_ENABLE_SYMBOL_VISIBILITY)

# OPTION(HTTRAQT_ENABLE_TESTING "Build the HTTraQt regression test suite." OFF)
# SET(BUILD_TESTING ${HTTRAQT_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(HTTRAQT_ENABLE_TESTING)
#     CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
#     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(HTTRAQT_ENABLE_TESTING)

# Find required external packages
HTTRAQT_CHECK_REQUIRED_DEPENDENCY(HTTRAQT_HTTRACK_FOUND "libhttrack2" "http://www.httrack.com" "")
# HTTRAQT_CHECK_OPTIONAL_DEPENDENCY(HTTRAQT_BUILD_3DS_IO_MODULE HTTRAQT_3DS_FOUND "lib3ds")

# Capture system configuration
INCLUDE(HTTRAQTSystemConfiguration)

# Win32 configuration
IF(WIN32)
    IF(NOT MSVC)
        SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
        SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(NOT MSVC)
ENDIF(WIN32)

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)

SET(HTTRAQT_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
IF(WIN32)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)
ELSE(WIN32)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/${HTTRAQT_LIBDIR})
ENDIF(WIN32)

# Setup a macro for compiling resources ...
MACRO(HTTRAQT_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

    GET_TARGET_PROPERTY(HTTRAQT_RESOURCE_COMPILER httraqt-resource-compiler LOCATION)

    ADD_CUSTOM_COMMAND(
        DEPENDS httraqt-resource-compiler
        DEPENDS ${INPUT_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
        COMMAND ${HTTRAQT_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
        OUTPUT ${OUTPUT_FILE}
        COMMENT "Compiling resource ${INPUT_FILE}"
        )

    LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})

ENDMACRO(HTTRAQT_COMPILE_RESOURCE)

# Setup subdirectories ...
HTTRAQT_CONDITIONAL_BUILD(MSVC gendef)

OPTION(HTTRAQT_ENABLE_DISTRIBUTION "Enable distribution targets." ON)
HTTRAQT_CONDITIONAL_BUILD(HTTRAQT_ENABLE_DISTRIBUTION distribution)

# Hide some cruft ...
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
MARK_AS_ADVANCED(CMAKE_EXECUTABLE_FORMAT)
MARK_AS_ADVANCED(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES)
MARK_AS_ADVANCED(CMAKE_OSX_DEPLOYMENT_TARGET)
MARK_AS_ADVANCED(CMAKE_OSX_SYSROOT)
MARK_AS_ADVANCED(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_USE_CHRPATH)

=== distribution/CMakeLists.txt ===
# Setup automatic generation of the changelog
MESSAGE(STATUS "CPack for Linux configuration..." )

SET( CPACK_SOURCE_PACKAGE_FILE_NAME "httraqt-${HTTRAQT_VERSION}" )
SET( CPACK_SOURCE_IGNORE_FILES
    "/\\\\.svn/"
    "/\\\\.kdev4/"
    "/\\\\.git/"
    "/pics/"
    "/build/"
    "~$"
    "\\\\.pcs$"
#     "TODO.txt"
#     "CMakeLists.txt.user"
#     "/doxygen/"
#     "${CMAKE_BINARY_DIR}"
)


# --- Package generation
SET( HTTRAQT_CPACK_BUILD_CONFIG "Release_and_Debug" )
SET( HTTRAQT_CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
SET( HTTRAQT_CPACK_PACKAGE_VENDOR "KarboSoft" )
SET( HTTRAQT_CPACK_PACKAGE_INSTALL_DIRECTORY "HTTraQt ${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_PACKAGE_INSTALL_REGISTRY_KEY "HTTraQt ${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_PACKAGE_HOMEPAGE "http://httraqt.sourceforge.net/" )


# Setup global packaging parameters ...
SET( HTTRAQT_CPACK_INSTALL_CMAKE_PROJECTS "${CURRENT_BUILD_DIR};httraqt;ALL;/" )
# MESSAGE("HTTRAQT_BINARY_DIR ${CURRENT_BUILD_DIR}")
SET( HTTRAQT_CPACK_PACKAGE_DESCRIPTION "HTTraQt free GUI for httrack library." )
SET( HTTRAQT_CPACK_PACKAGE_FILE_NAME "httraqt-setup-${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_PACKAGE_VERSION "${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENCE" )
SET( HTTRAQT_CPACK_SOURCE_IGNORE_FILES "/CVS/;/.svn/;/.hg/" )
SET( HTTRAQT_CPACK_SOURCE_INSTALLED_DIRECTORIES "${PROJECT_SOURCE_DIR};/" )
SET( HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME "httraqt-source-${HTTRAQT_VERSION}" )

# SET( HTTRAQT_CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME} )
SET( HTTRAQT_CPACK_PACKAGE_VERSION ${HTTRAQT_VERSION} )
SET( HTTRAQT_CPACK_PACKAGE_RELEASE 0 )
SET( HTTRAQT_CPACK_PACKAGE_MAINTAINER "Eduard Kalinowski <eduard_kalinowski@yahoo.de>" )
SET( HTTRAQT_CPACK_PACKAGE_MAINTAINER_NAME "Eduard Kalinowski" )
SET( HTTRAQT_CPACK_PACKAGE_MAINTAINER_EMAIL "eduard_kalinowski@yahoo.de" )
SET( HTTRAQT_CPACK_PACKAGE_DESCRIPTION "HTTraQt is the website copier for offline browsing" )
SET( HTTRAQT_CPACK_PACKAGE_DESCRIPTION_SUMMARY "HTTraQt network tool" )
# SET( PACKAGE_DEPENDS ${hugr_dependencies} )

SET( HTTRAQT_CPACK_PACKAGE_SHLIBDEPS ON )
#SET( HTTRAQT_CPACK_PACKAGE_DEPENDS "libhttrack2, libqtcore4, libqtgui4, libc6, libstdc++6" )
SET( HTTRAQT_CPACK_PACKAGE_DEPENDS "libhttrack2, libqtcore4, libqtgui4" )
# SET( PACKAGE_DEPENDS "libc6 (>= 2.1.3), libhttrack (>= 3.42.1), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1)" )


SET( HTTRAQT_CPACK_PACKAGE_GROUP "Groupe" )
SET( HTTRAQT_CPACK_PACKAGE_LICENSE "GPL3" )

# ADD_CUSTOM_TARGET(changelog
# 	COMMAND ${GITCOMMAND} log > ${HTTRAQT_BINARY_DIR}/ChangeLog
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

# Setup convenience targets for tagging and branching
# SET( HTTRAQT_VERSION_TAG "httraqt-${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION}" )
# SET( HTTRAQT_VERSION_TAG "httraqt-${HTTRAQT_VERSION}" )
# ADD_CUSTOM_TARGET(tag-version
# 	COMMAND ${GITCOMMAND} tag ${HTTRAQT_VERSION_TAG}
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

#SET( HTTRAQT_BRANCH_TAG "httraqt-release-${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}" )
#ADD_CUSTOM_TARGET(tag-branch
#	COMMAND ${SVNCOMMAND} cp ${HTTRAQT_SVN_TRUNK}
#	${HTTRAQT_SVN_BRANCHES}/${HTTRAQT_BRANCH_TAG} -m "COMP: Branched HTTraQt Version ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}"
#	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
#	)
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR distr ${CMAKE_CURRENT_SOURCE_DIR} : ${PROJECT_SOURCE_DIR}")
# Get a SourceForge username so we can upload distributables to the FRS
IF(WIN32)
	SET( HTTRAQT_SOURCEFORGE_USERNAME "$ENV{USERNAME}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
ELSE(WIN32)
	SET( HTTRAQT_SOURCEFORGE_USERNAME "$ENV{USER}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
ENDIF(WIN32)
MARK_AS_ADVANCED(HTTRAQT_SOURCEFORGE_USERNAME)



# Setup some macros that can be used by the platform-specific distribution logic
MACRO(HTTRAQT_CHECK_INSTALLED_VERSION FOUND PACKAGE EXPECTED)
	IF(NOT ${FOUND} STREQUAL ${EXPECTED})
		MESSAGE(SEND_ERROR "Found ${PACKAGE} version ${FOUND} - for installation, version ${EXPECTED} is required." )
	ENDIF(NOT ${FOUND} STREQUAL ${EXPECTED})
ENDMACRO(HTTRAQT_CHECK_INSTALLED_VERSION)



# Generate source packages
# ADD_SUBDIRECTORY(source)
INCLUDE(CPack)

# Generate platform-specific binary packages
IF(APPLE)
	ADD_SUBDIRECTORY(osx)
ENDIF(APPLE)

IF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(posix)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
	ADD_SUBDIRECTORY(win32)
ENDIF(WIN32)

=== distribution/posix/CMakeLists.txt ===
SET(CPACK_STRIP_FILES TRUE)
SET(CMAKE_INSTALL_PREFIX "/usr")

#MESSAGE("CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}")

SET( CPACK_PACKAGE_GROUP "${HTTRAQT_CPACK_PACKAGE_GROUP}" )
SET( CPACK_PACKAGE_LICENSE "${HTTRAQT_CPACK_PACKAGE_LICENSE}" )
SET( CPACK_PACKAGE_SHLIBDEPS "${HTTRAQT_CPACK_PACKAGE_SHLIBDEPS}" )
SET( CPACK_PACKAGE_DEPENDS "${HTTRAQT_CPACK_PACKAGE_DEPENDS}" )

INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/httraqt" DESTINATION bin COMPONENT applications)
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons" DESTINATION "/usr/share/" FILES_MATCHING PATTERN "*.*") 
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang" DESTINATION "/usr/share/httraqt/" FILES_MATCHING PATTERN "*.*") 
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/help" DESTINATION "/usr/share/httraqt/" FILES_MATCHING PATTERN "*.*") 
# MESSAGE("PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}")

SET( desktop "${PROJECT_SOURCE_DIR}/desktop/httraqt.desktop")

INSTALL(FILES ${desktop}
        DESTINATION "/usr/share/applications/"
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)
        
SET(CPACK_INSTALL_CMAKE_PROJECTS "${HTTRAQT_CPACK_INSTALL_CMAKE_PROJECTS}")

SET(HTTRAQT_PACKAGE_DIRECTORY "${CURRENT_BUILD_DIR}")
# FILE(MAKE_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}")
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR posix ${CMAKE_CURRENT_SOURCE_DIR}")
# MESSAGE("DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

# if not defined
IF(NOT DEBIAN_ARCHITECTURE)
    execute_process(
      COMMAND dpkg --print-architecture
      OUTPUT_VARIABLE DEBIAN_ARCHITECTURE
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  #SET(DEBIAN_ARCHITECTURE i386) #dpkg --print-architecture is always i386 on intel
ENDIF(NOT DEBIAN_ARCHITECTURE)

IF(DEBIAN_ARCHITECTURE)
    MESSAGE("DEBIAN_ARCHITECTURE ${DEBIAN_ARCHITECTURE}")
    SET( HTTRAQT_CPACK_PACKAGE_FILE_NAME "httraqt-${HTTRAQT_VERSION}-${DEBIAN_ARCHITECTURE}" )
    
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-deb.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack)
    ADD_CUSTOM_TARGET(package-binary-deb
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack
        )
ENDIF()

IF(NOT RPM_ARCHITECTURE)
    FIND_PROGRAM(RPMBUILD
        NAMES rpmbuild
        PATHS "/usr/bin")

    IF ( RPMBUILD )
        GET_FILENAME_COMPONENT(RPMBUILD_PATH ${RPMBUILD} ABSOLUTE)
        MESSAGE(STATUS "Found rpmbuild : ${RPMBUILD_PATH}")
        SET(RPMBUILD_FOUND "YES")
        execute_process(
           COMMAND arch
           OUTPUT_VARIABLE RPM_ARCHITECTURE
           OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    ENDIF ( RPMBUILD )
ENDIF()

IF(RPM_ARCHITECTURE)
    MESSAGE("RPM_ARCHITECTURE ${RPM_ARCHITECTURE}")
    SET( HTTRAQT_CPACK_PACKAGE_FILE_NAME "httraqt-${HTTRAQT_VERSION}-${RPM_ARCHITECTURE}" )
    
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-rpm.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack)
    ADD_CUSTOM_TARGET(package-binary-rpm
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack
        )
ENDIF()

# Generate self-extracting tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-stgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack)
ADD_CUSTOM_TARGET(package-binary-stgz
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack
        )

# Generate tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tbz2.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack)
ADD_CUSTOM_TARGET(package-binary-tbz2
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack
        )

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack)
ADD_CUSTOM_TARGET(package-binary-tgz
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack
        )

# Note ... we intentionally don't provide upload capability for Posix packages, and leave distribution to the experts

=== sources/main/CMakeLists.txt ===
#CMakeLists.txt

set(MAIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/translator.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/htinterface.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/options.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/httraqt.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/AboutDialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/buttonPanel.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ConfirmTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/FinalTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/InsertUrlDialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/NewProjTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/OptionsTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ProgressTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/StartTab.cpp
                PARENT_SCOPE)

set(MAIN_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/includes/httraqt.h
#                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htsnet.h
                ${CMAKE_CURRENT_SOURCE_DIR}/includes/htinterface.h
#                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htsstrings.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/options.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/translator.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/AboutDialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/buttonPanel.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/FinalTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/../version.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/InsertUrlDialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/NewProjTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/ProgressTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/ConfirmTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/OptionsTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/StartTab.h
                PARENT_SCOPE)


set(MAIN_FORMS  ${CMAKE_CURRENT_SOURCE_DIR}/forms/AboutDialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/buttonPanel.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/ConfirmTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/FinalTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/InsertUrlDialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/mainForm.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/NewProjTab.ui 
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/ProgressTab.ui 
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/StartTab.ui
                PARENT_SCOPE)

#QT4_WRAP_CPP(MAIN_HEADERS_MOC ${MAIN_HEADERS})
#QT4_WRAP_UI(MAIN_FORMS_HEADERS ${MAIN_FORMS})


# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== distribution/osx/packagemaker/CMakeLists.txt ===
# The CPack PackageMaker generator ignores CMAKE_INSTALL_PREFIX and places everything in /usr, complain if there is a mismatch
IF(NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr")
       MESSAGE(SEND_ERROR "HTTRAQT_CREATE_PACKAGEMAKER_PACKAGE requires CMAKE_INSTALL_PREFIX set to \"/usr\".")
ENDIF(NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr")

# Generate a packagemaker package ...
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/COPYING ${CMAKE_CURRENT_BINARY_DIR}/COPYING.txt COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-packagemaker.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-packagemaker.cpack)

ADD_CUSTOM_TARGET(package-binary-packagemaker
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-packagemaker.cpack
	)

=== debian/changelog ===
httraqt (1.4.7-1) unstable; urgency=medium

  * [ebd5cc4] Imported Upstream version 1.4.7
  * [7fb1de2] Ignore quilt dir

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Dec 2015 12:39:24 +0100

=== debian/control ===
Source: httraqt
Maintainer: Anton Gladky <gladk@debian.org>
Section: web
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libhttrack-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtmultimedia5-dev,
               libssl-dev
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/httraqt.git
Vcs-Git: git://anonscm.debian.org/collab-maint/httraqt.git
Homepage: http://httraqt.sourceforge.net/

Package: httraqt
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: program for downloading of internet sites
 Program is intended for loading of Internet pages and/or their contents,
 equipped with flexible system of settings.
 HTTraQt - graphical user interface (GUI) for HTTrack library,
 developed in C++ and based on multiplatform Qt library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

export BUILD_DATE=$(shell dpkg-parsechangelog -S Date)

override_dh_installchangelogs:
	dh_installchangelogs README

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DATE="$(BUILD_DATE)"

## httraqt 1.4.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,7 +78,7 @@
 SET(HTTRAQT_PACKAGE httraqt)
 # SET(HTTRAQT_VERSION ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION})
 SET(HTTRAQT_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
-SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2015, Eduard Kalinowski. All Rights Reserved.")
+SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2017, Eduard Kalinowski. All Rights Reserved.")
 SET(HTTRAQT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
 
 # Setup high-level build options

=== debian/changelog ===
httraqt (1.4.8-1) unstable; urgency=medium

  * [4270897] Apply cme fix dpkg.
  * [0ed07ed] Use compat level 10.
  * [8a0fa26] New upstream version 1.4.8

 -- Anton Gladky <gladk@debian.org>  Fri, 20 Jan 2017 20:14:59 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --parallel
+	dh $@
 
 export BUILD_DATE=$(shell dpkg-parsechangelog -S Date)

## httraqt 1.4.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,13 +6,33 @@
 CMAKE_POLICY(SET CMP0015 OLD)
 
 # if you use the version 5, please change it to 5
-SET(USE_QT_VERSION 4)
+SET(USE_QT_VERSION 5)
 
 MESSAGE("Qt version for compiling: " ${USE_QT_VERSION})
 
 IF(NOT ${USE_QT_VERSION} MATCHES "4" AND NOT ${USE_QT_VERSION} MATCHES "5")
     MESSAGE(FATAL_ERROR "-- Qt version must be set to 4 or 5!")
 ENDIF()
+
+
+OPTION (USE_DEBUGGER "Include in binary file debug information" OFF)
+SET(USE_DEBUGGER false)
+
+#enable or disable profiling info
+# SET(USE_PROFILER false)
+
+OPTION (USE_PROFILER "Include in binary file profiling information" OFF)
+
+
+
+IF(${USE_DEBUGGER})
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
+ELSE()
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_RELEASE} -Wall")
+ENDIF()
+
+MESSAGE(STATUS "CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}")
+
 
 # INCLUDE(CPack)
 INCLUDE(CheckIncludeFile)
@@ -81,6 +101,21 @@
 SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2017, Eduard Kalinowski. All Rights Reserved.")
 SET(HTTRAQT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
 
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions -fno-rtti")
+
+# options for gprof 
+IF(${USE_PROFILER})
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
+  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
+  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")
+  # after execution of program: gprof ./build/ponyprog
+  # and get the information from gprof.txt file
+  MESSAGE(STATUS "Compile with profiling information")
+ELSE()
+  MESSAGE(STATUS "Compile without profiling information")
+ENDIF()
+
+
 # Setup high-level build options
 IF(WIN32 AND MSVC)
     SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
@@ -115,17 +150,19 @@
 
 SET( HTTRACK_INCLUDES_DIR "" )
 
-IF(${USE_QT_VERSION} MATCHES "4")
-  INCLUDE_DIRECTORIES(${QT_INCLUDES})
+SET(HTTRAQT_CPACK_PACKAGE_SHLIBDEPS ON)
+
+IF(${USE_QT_VERSION} MATCHES "4")
+    INCLUDE_DIRECTORIES(${QT_INCLUDES})
     MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
-    LINK_DIRECTORIES(${QT_LIBRARY_DIR})
+#     LINK_DIRECTORIES(${QT_LIBRARY_DIR})
     MESSAGE(STATUS "QT_LIBRARY_DIR ${QT_LIBRARY_DIR}")
 ELSE()
     INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS})
     MESSAGE(STATUS "QT_INCLUDES  ${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS}")
 #     LINK_DIRECTORIES(${Qt5Core_LIBRARIES}, ${Qt5Multimedia_LIBRARIES}, ${Qt5DBus_LIBRARIES}, ${Qt5Widgets_LIBRARIES})
 #     MESSAGE(STATUS "QT_LIBRARY_DIR ${Qt5Core_LIBRARIES}, ${Qt5Multimedia_LIBRARIES}, ${Qt5DBus_LIBRARIES}, ${Qt5Widgets_LIBRARIES}")
-    SET(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
+#     SET(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
 ENDIF()
 
 SET ( OBJECTS_DIR temp )
@@ -162,6 +199,11 @@
     ${APP_FORMS_HEADERS}
     ${APP_RESOURCES_RCC}
 )
+
+IF(NOT ${USE_DEBUGGER})
+    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
+    #ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT)
+ENDIF()
 
 IF(${USE_QT_VERSION} MATCHES "4")
     INCLUDE(${QT_USE_FILE})

=== debian/changelog ===
httraqt (1.4.9-5) unstable; urgency=medium

  * Install doc-files in /usr/share/httraqt. (Closes: #990895)

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Jul 2021 22:16:58 +0200

httraqt (1.4.9-4) unstable; urgency=medium

  * [936829d] Fix section in manpage. (Closes: #963343)
  * [bfcbef7] Set upstream metadata fields: Repository.

 -- Anton Gladky <gladk@debian.org>  Sun, 28 Jun 2020 22:51:33 +0200

httraqt (1.4.9-3) unstable; urgency=medium

  * [73a80e9] Fix FTCBFS. (Closes: #917999)

 -- Anton Gladky <gladk@debian.org>  Tue, 05 May 2020 22:03:16 +0200

httraqt (1.4.9-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org
  * d/watch: Use https protocol

  [ Anton Gladky ]
  * [ec12447] Trim trailing whitespace.
  * [1211c30] Bump debhelper from old 10 to 13.
  * [2b59c22] Set debhelper-compat version in Build-Depends.
  * [7bc16bb] Set Standards-Version to 4.5.0
  * [2058dca] Add Rules-Requires-Root: no
  * [5a1c40e] Add debian/.gitlab-ci.yml
  * [fb206c6] Move docs into the /usr/share/doc/htttraqt

 -- Anton Gladky <gladk@debian.org>  Mon, 04 May 2020 07:17:24 +0200

httraqt (1.4.9-1) unstable; urgency=medium

  * [fa67d0e] Update d/watch.
  * [c05647b] Set maximal hardening level.
  * [6eff4ab] Update patches
  * [167a718] New upstream version 1.4.9

 -- Anton Gladky <gladk@debian.org>  Tue, 18 Jul 2017 23:23:36 +0200

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,17 @@
 Maintainer: Anton Gladky <gladk@debian.org>
 Section: web
 Priority: optional
+Rules-Requires-Root: no
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper-compat (= 13),
                libhttrack-dev,
                qtbase5-dev,
                qtbase5-dev-tools,
                qtmultimedia5-dev,
                libssl-dev
-Standards-Version: 3.9.6
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/httraqt.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/httraqt.git
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/debian/httraqt
+Vcs-Git: https://salsa.debian.org/debian/httraqt.git
 Homepage: http://httraqt.sourceforge.net/
 
 Package: httraqt

=== debian/watch ===
version=3
https://sf.net/httraqt/httraqt-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)) debian uupdate
